Attribute VB_Name = "Module1"
' the novapiLib and novapiLibDemo packages must be added as a COM reference
Const PRINTER_NAME As String = "novaPDF SDK 9"
Const PROFILE_NAME As String = "Test VB"
Const PROFILE_IS_PUBLIC As Long = 0

' The main entry point for the application.
Public Sub Main()
    On Error GoTo ErrorHandler:
    
    ' create the NovaPdfOptions object
    Dim pNova As New NovaPdfOptions90
    Dim sOldActiveProfileID As String
    Dim sNewProfileID As String

    ' initialize the NovaPdfOptions object to use with a printer licensed for SDK
    pNova.Initialize2 PRINTER_NAME, ""

    On Error Resume Next
    'pNova.GetActiveProfile2 (sOldActiveProfileID)
    
    On Error GoTo ErrorHandler:
    ' make new profile
    pNova.AddProfile2 PROFILE_NAME, PROFILE_IS_PUBLIC, sNewProfileID
    pNova.LoadProfile2 (sNewProfileID)
    ' and set some options
    ' uncomment the function calls for the options you wish to set and change the options in the Nova.vb unit

    'DO NOT OPEN PDF
    'an Open action is added by default in the profile - delete or disable this open action
    'pNova.DisableActionType NOVA_ACTION_OPEN
    '-----------------
    'AddProfileOptions pNova
    'AddDocumentInformation pNova
    'AddDocumentXMPMetadata pNova
    'AddViewerOptions pNova
    'AddLinksOptions pNova
    'AddAdvancedOptions pNova
    'AddGraphicsOptions pNova
    'AddEmbedFontsOptions pNova
    'AddBookmarksDefinitions pNova
    'AddSecurity pNova
    'AddSaveOptions pNova
    'AddMergeOptions pNova
    'AddWatermarkImage pNova
    'AddWatermarkText pNova
    'AddPageContentOptions pNova
    'AddOverlayOptions pNova
    'AddSignatureOptions pNova
    'AddActionsOptions pNova
    '-----------------
    'save profile changes
    pNova.SaveProfile
    'set as active profile for printer
    pNova.SetActiveProfile (sNewProfileID)

    ' Print a test page
    Dim myPrinter As Printer
   
    For Each myPrinter In Printers
        If myPrinter.DeviceName = PRINTER_NAME Then
            Set Printer = myPrinter
            Exit For
        End If
    Next
    
    Printer.FontName = "Arial"
    Printer.FontSize = 16
    Printer.CurrentX = 20
    Printer.CurrentY = 20
    
    Printer.Print "novaPDF says Hello World from VB"
    Printer.EndDoc

    'restore default profile
    If Len(sOldActiveProfileID) > 0 Then
        pNova.SetActiveProfile2 (sOldActiveProfileID)
    End If

    'delete newly created profile
    pNova.DeleteProfile2 (sNewProfileID)

    Exit Sub
ErrorHandler:
    Debug.Print (Err.Number & ":" & Err.Description)
End Sub
